#include "mex.h"
#include <math.h>

// To be used by
//  [fA] = submod_fval_group(A, graph)
//  Computes the submodular function value of group sparsity
// Input: 
//   A: a 0/1 vector showing if each node is picked
//   graph: the sparse matrix (#var * #group) that encodes group structure
// Output:
//   fA: the submodular value value of A
void mexFunction (int nlhs, mxArray *plhs[], 
                  int nrhs, const mxArray *prhs[]) 
{
  mwIndex num_group;
  mwIndex *jc, *ir;
  mwIndex i, j, nnz;  
  mxLogical *x;
  double res;

  x = mxGetLogicals(prhs[0]);
  jc = mxGetJc(prhs[1]);    ir = mxGetIr(prhs[1]);

  num_group = mxGetN(prhs[1]);
  res = 0.0;
  for (i = 0; i < num_group; i++)  
  {    
    nnz = jc[i+1] - jc[i];
    
    for (j = 0; j < nnz; j ++)
    {
      if (x[*(ir+j)])
        break;
    }
    ir += nnz;
    if (j < nnz)
      res += 1.0;
  }

  plhs[0] = mxCreateDoubleScalar(res);
//   res = 0;
//   for (i =0; i < mxGetM(prhs[1]); i ++)
//   {
//     if(x[i])
//       res = res + 1.0;
//   }
//   mexPrintf("Number of true in x: %f\n", res);
  
}
