function res = par_def_general()
  
  res = [];
  
  % Experiment settings
  res.exp_par = struct('p', inf, ...
                       'lambda_str', '1e-2', ...
                       'lambda', 1e-2, ...
                       'max_time', 5000 ...
                       );
   %      'p', inf, 2, ...
%                           'lam_col', 1, ...
%                        'lam_row', 1, ...
%                        'col', ori_par.col, ...
%                        'row', ori_par.row ...

  % Parameter for polar operator   
  opt = struct('verbose', 2, ...
               'optTol', 1e-6, ...
               'progTol', 1e-6, ...
               'maxIter', 30 ...
               );
  res.polar_par = struct('sigma', 1e-10, ...   % for smoothing the polar operator
                         'check_LP', false, ... % Run LP to double check PO
                         'minConf_PQN_opt', opt, ...
                         'secant_tol', 1e-4, ...
                         'use_maxflow_bk', false, ...
                         'use_maxflow_darwin', true, ...
                         'verbose', 1 ...
                         );
  
  % Paramter for conditional gradient
  res.cg_par = struct('max_cg_iter', 50, ...
                      'sigma', 1e-5, ...  % for smoothing L_\inf in local opt
                      'use_conic', true, ...
                      'conic_search', 'total', ...
                      'use_local', false, ...
                      'max_time', 7200, ...
                      'verbose', 1 ...
                      );
  
  % Parameter for conic search
  res.cone_par = struct('maxIter', 2000, ...
                        'maxFnCall', 70, ...
                        'relCha', 1e-5, ...
                        'tolPG', 1e-5, ...
                        'm', 20, ...
                        'monitor', [], ...
                        'print_summary', true ...
                        );
%                         'monitor', @genericcallback, ...

  % Parameter for local search
  res.local_par = struct('maxIter', 100, ...
                         'maxFnCall', 20, ...
                         'relCha', 1e-5, ...
                         'tolPG', 1e-5, ...
                         'm', 20, ...
                         'monitor', [], ...
                         'print_summary', true ...
                         );
%                          'monitor', @genericcallback, ...

  % Nesterov settings 
  res.opts_nest = struct('max_iter', 1000, ...
                         'max_prox_eval', 20000, ...
                         'fval_tol', -1e-6, ...
                         'gamma_d', 1.2, ...
                         'gamma_u', 1.3, ...
                         'init_L', 0.5, ...
                         'verbose', 2, ...
                         'weight_reg', res.exp_par.lambda, ...
                         'max_time', 3600 ...
                         );
  
  % Nesterov's Proximal Operator settings
  res.par_prox = struct('lambda', res.exp_par.lambda, ...
                        'regul', 'graph', ...
                        'verbose', true, ...
                        'num_threads', -1, ...
                        'intercept', false ...
                        );
    
  res.algo = 'gcg_secant';
  
end
