% clear;  clc;  close all;

function script_general_group(par)

  global root y_g
  res_dir = [root '/result/general_group'];

  eval(['load ' par.dname '.mat;']);

  X = data(:, 2:end);  % remove column 1 which is the label

%   X = X(1:60, 1:200);  % subsample for efficient debug
%   X = X(1:4,1:3);

  % start_spams;

  par = load_par(par);
  
  if ischar(par.graph_source)
    load(par.graph_source);
    assert(exist('graph', 'var'));
  else
    graph = par.graph_source;
  end

  par.graph = grlist_to_graph(graph, par);
  par.sbd_oracle = @submod_oracle_group;
  par.sbd_fun = @(A, sbd_ctx, par)submod_fval_group(A, sbd_ctx.V_by_G);    
  par.sbd_restrict = @submod_restrict_group;
  par.get_secant_init = @get_secant_init_group;
  par.sbd_ctx.G_by_V = par.graph.G_by_V;
  par.sbd_ctx.V_by_G = par.graph.V_by_G;
  par.graph = rmfield(par.graph, {'G_by_V', 'V_by_G'});

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  X = X - repmat(mean(X, 2), 1, size(X,2));
  X = mexNormalize(X);  % Rescale the columns of X so that they have unit l2-norm

  loss = @(W)obj_vec_regress(W, X);

  W0 = zeros(numel(X), 1);

  if par.use_fista
    prox_op = @(W,nest_par)prox_op_group(W, nest_par, par);
    par.opts_nest.lambda = par.exp_par.lambda;
    [W, obj, res] = minFISTA(loss, prox_op, W0, par.opts_nest);
  % [W, obj, msg] = minNesterov(loss, reg, prox_op, W0, par.opts_nest);
    fname = [res_dir '/CUR_' dname '_p=' num2str(par.exp_par.p) ...
             '_lam=' par.exp_par.lambda_str '_fista.mat'];
%     par_fista = par;
%     save(fname, 'res_fista', 'par_fista');    
  end

  if par.use_gcg
    switch par.polar_par.polar_oracle
      case 'smooth'
        pola = @(g)polar_op_smooth_group(g, par);
        num_group = size(par.graph.G_by_V, 1);
        y_g = ones(num_group, 1)/num_group;
      case 'secant'
        pola = @(g)polar_op_Secant(g, par);
%         par.backup_pola = @(g)polar_op_smooth_group(g, par);
      otherwise
        warning(['Unexpected polar oracle type ' par.polar_par.polar_oracle]);
    end

    reg = @(w)reg_group(w, par.sbd_ctx, par);

    [w, f, res] = gcg_vec(loss, pola, reg, W0, par);
    
    fname = [res_dir '/gen_group_' dname '_p=' num2str(par.exp_par.p) ...
             '_lam=' par.exp_par.lambda_str ...
             '_' par.polar_par.polar_oracle '.mat'];
           
%     eval(['res_gcg_' par.polar_par.polar_oracle ' = res_gcg;']);
%     eval(['par_' par.polar_par.polar_oracle ' = par;']);
%     save(fname, ['res_gcg_' par.polar_par.polar_oracle], ...
%                 ['par_' par.polar_par.polar_oracle]);    
  end
  save(fname, 'res', 'par');
end
