function eval_fun = make_eval_multiview(X2, lambda, opts)

w = [opts.weight_X1, opts.weight_X2, opts.weight_Y];
m = opts.num_f1+opts.num_f2+opts.num_class;
n = size(X2, 2);
l = opts.num_f1 + opts.num_f2;

eval_fun = @eval_function;

  function perf = eval_function(U)
    % First decode to get the optimal Phi
    
    nest_opts = opts;
    nest_opts.init_L = 0.01;
    nest_opts.max_iter = 30;
    nest_opts.verbose = 0;
    nest_opts.alpha = lambda;
    V = randn(size(U, 2), n);
    [V, obj, msg] = solve_Nesterov_generic(@obj_V, @L21_loss, @prox_op_L21, V, nest_opts);

    % Use V to predict X2
    X2_hat = U(opts.num_f1+1:l,:)*V;
    perf = 1-sum(sum(sign(X2_hat .* X2) == 1)) / numel(X2); 

      function [f, g] = obj_V(V)
        [f1, G1] = opts.L1_te(U(1:opts.num_f1,:)*V);
        [f3, grads] = opts.L3_te(U(l+1:end,:)*V); 

        f = w(1)*f1 + w(3)*f3;
        g = w(1)*U(1:opts.num_f1,:)'*G1 + w(3)*U(l+1:end,:)'*grads;
      end
  end
 
end
