clear par;
rand('state', 0);   randn('state', 0);

ori_par.dataset = 'mv_face';
ori_par.eval_view = 'Y';
ori_par.prob_par = struct('sigma', 1e-4, ...
                          'w1', 1, ...
                          'w2', 1, ...
                          'alpha', 1, ...
                          'beta', 1 ...
                          );
                        
% lambda_list = {'30', '20', '10', '1', '0.1'};
% k_list = [200, 100, 70, 40, 10, 5];

% lambda_list = {'40', '30', '20'};
lambda_list = {'50'};
k_list = [200, 100, 70, 40];

for lambda = lambda_list
  
  fprintf('lambda = %s\n', cell2mat(lambda));
  
  ori_par.lambda_str = cell2mat(lambda);
  init_rank = 20;
  rtol = 1e-4;

  par = ori_par;
  par.algo = 'LOB';
  par.init_rank = init_rank;
  par.max_iter = 500;
  par.max_time = 3600;
  par.lbfgsb_in.maxIter = 100;
  par.lbfgsb_in.maxFnCall = 100;
  par.lbfgsb_in.relCha = 1e-5;	 % tolerance of constraint satisfaction
  par.lbfgsb_in.tolPG = 1e-5;		 % final objective function accuracy parameter
  par.lbfgsb_in.view = [];
  script_multiview(par);
  
%   return
  
  for k = k_list
    par = ori_par;
    par.algo = 'BCD';
    par.k = k;
    par.max_iter = 500;
    par.max_time = 3600;
    par.fista_B_par.verbose = 0;
    par.fista_C_par.verbose = 0;
    par.fista_H_par.verbose = 0;
    script_multiview(par);
    fprintf('k = %d\n', k);
  end
end


par = ori_par;
par.algo = 'LS';
% par.max_iter = 100;
% par.max_time = 3600*10;
% par.lbfgsb_in.maxIter = 40;
% par.lbfgsb_in.maxFnCall = 40;
% par.lbfgsb_in.relCha = 1e-4;	 % tolerance of constraint satisfaction
% par.lbfgsb_in.tolPG = 1e-4;		 % final objective function accuracy parameter
% par.lbfgsb_in.view = [];
% script_multiview(par);

gvalue = get_global_value();
if gvalue.is_cluster,   quit;   end
